package com.vaadin.demo.mobilemail;

import com.vaadin.addon.touchkit.server.TouchKitServlet;
import com.vaadin.addon.touchkit.settings.TouchKitSettings;
import com.vaadin.addon.touchkit.settings.ViewPortSettings;
import com.vaadin.server.*;
import com.vaadin.ui.UI;

import javax.servlet.ServletException;

public class MobileMailServlet extends TouchKitServlet {

    private final UIProvider uiProvider = new UIProvider() {

        @Override
        public Class<? extends UI> getUIClass(UIClassSelectionEvent event) {
            return MobileMailUI.class;
        }
    };

    @Override
    protected void servletInitialized() throws ServletException {
        super.servletInitialized();

        getService().addSessionInitListener(new SessionInitListener() {
            @Override
            public void sessionInit(SessionInitEvent event)
                    throws ServiceException {
                event.getSession().addUIProvider(uiProvider);
            }
        });

        TouchKitSettings s = getTouchKitSettings();
        s.getWebAppSettings().setWebAppCapable(true);
        s.getWebAppSettings().setStatusBarStyle("black");
        ViewPortSettings viewPortSettings = new ViewPortSettings();
        viewPortSettings.setViewPortInitialScale(1f);
        viewPortSettings.setViewPortMaximumScale(1f);
        viewPortSettings.setViewPortUserScalable(false);
        viewPortSettings.setViewPortWidth("device-width");
        s.setViewPortSettings(viewPortSettings);
        String contextPath = getServletConfig().getServletContext()
                .getContextPath();

        s.getApplicationIcons().addApplicationIcon(
                contextPath + "/VAADIN/themes/mobilemail/apple-touch-icon.png");
    }
}
